<?xml version="1.0" encoding="UTF-8"?>
<DeployScript><Scripts><KScript><id>IfaxdtTG</id><number>bos_devp_sample_control</number><cmb_ftype></cmb_ftype><scripttype>9</scripttype><context><![CDATA[/**
* @author IERP
* @date 2019-07-15
*/
var plugin = new BillPlugin({
    KEY_ENTRYENTITY : "entryentity",
	preOpenForm : function(e){
        
    },
    registerListener : function(e){
        this.addClickListeners("tripentry","accountentry");
    },
    click : function(e){
        var item = e.getSource();
		if("tripentry".equals(item.getKey())){
			this.rebuildGridCols(item.getKey());
		}else if("accountentry".equals(item.getKey())){
			this.rebuildGridCols(item.getKey());
		}
    },
    rebuildGridCols : function(entryKey){
        // 创建表格元数据
		var gridMeta = this.createGridColumns(entryKey);
		// 发送到前端
		var clientViewProxy = this.getView().getClientProxy();
		clientViewProxy.preInvokeControlMethod(this.KEY_ENTRYENTITY, "createGridColumns", gridMeta);
		// 创建表格当前页数据包
		var pageIndex = 1;
		var grid = this.getView().getControl(this.KEY_ENTRYENTITY);
		grid.getEntryState().setCurrentPageIndex(pageIndex);
		var data = this.createGridPageData(pageIndex,entryKey);
		// 发送到前端
		clientViewProxy.setEntryProperty(this.KEY_ENTRYENTITY, "data", data);
    },
    createGridPageData : function(pageIndex, entryKey){
        
		// rows : 打包当前页的数据
		var rows = this.createRowsData(pageIndex, entryKey);
		
		var data = new HashMap();
		data.put('rowcount', 1);		// 总行数
		data.put('rows', rows);			// 表格数据
		data.put('pagerows', 10);		// 每页行数
		data.put('pageindex', pageIndex);		// 当前页码
		data.put('isSplitPage', true);	// 是否分页：需要提前在设计器中，勾选单据体表格的"分页"选项才会支持分页

		data.put('pagecount', 2);		// 总页数
		data.put('datacount', 1);
		
		// dataIndex: 发送到前端的表格数据数组中，各项数据代表的含义
		var dataIndex = this.createDataIndex(data,entryKey);
		
		data.put('dataindex', dataIndex);
		
		return data;
    },
    createDataIndex : function(data, entryKey) {
        var dataIndex = new HashMap();
		dataIndex.put('rk', 0);		// 第一列：行标识
		dataIndex.put('id', 1);			// 第三列：树单据体，本行数据标识
		
		
		if("accountentry" == entryKey){
			dataIndex.put('payer', 2);	// 可见字段列
			dataIndex.put('payerbank', 3);	// 可见字段列
			dataIndex.put('payeraccount02', 4);	// 可见字段列
		}else if("tripentry" ==entryKey){
			dataIndex.put('startdate', 2);	// 可见字段列
			dataIndex.put('enddate', 3);	// 可见字段列
			dataIndex.put('from', 4);	// 可见字段列
			dataIndex.put('to', 5);	// 可见字段列
			dataIndex.put('vehicle', 6);	// 可见字段列
			dataIndex.put('tripexpenseitem', 7);	// 可见字段列
		}
		
		var i = data.size()+1;
		dataIndex.put('l', i);		// 各列锁定性
		dataIndex.put('s', i+1);	// 各列风格
		dataIndex.put('vi', i+2);	// 可见性
		dataIndex.put('cprop', i+3);	// 其他自定义属性
		return dataIndex;
    },
    createRowsData : function(pageIndex, entryKey){
        // 各行数据包
		var rows = new ArrayList();
		
		var seq = 1;
		var row = new ArrayList();
			
		// 固定列
		row.add(0);			// 第一列：行标识：0 ~ 9，总是从0开始
		row.add(1);		// 第二列：行序号：1 ~ 10， 自然数
			
		// 业务数据列
		this.createColumnData(row,entryKey);
			
		// 固定列，锁定性和分格,可见性
		row.add([0]);
		row.add([0]);
		row.add([0]);
		row.add([0]);
			
		rows.add(row);
		
		return rows;
    },
    createGridColumns : function(entryKey){
         var columns = new ArrayList();		
		
		if("tripentry".equals(entryKey)){
			this.createTripEntryColumn(columns);
		}else if("accountentry".equals(entryKey)){
			this.createAccountColumn(columns);
		}
				
		var gridMeta = new HashMap();
		gridMeta.put('rk', "rk");
		gridMeta.put('seq', "seq");
		gridMeta.put('columns', columns);
		gridMeta.put('vi', 63);
		
		return gridMeta;
    },
    createColumnData : function(rows, entryKey){
        if("accountentry" == entryKey){
			rows.add("IERP");
			rows.add("xx银行");
			rows.add("1234567");
		}else if("tripentry" == entryKey){
			rows.add(new Date("2018-08-15"));
			rows.add(new Date("2018-08-30"));
			
			rows.add("广州");
			rows.add("北京");
			rows.add(1);
			rows.add(null);
		}
    },
    createAccountColumn : function(columns){
        columns.add(this.createColumn("payer","收款人","basedata","100px"));
		columns.add(this.createColumn("payerbank","开户银行","basedata","100px"));
		columns.add(this.createColumn("payeraccount02","银行账号","text","100px"));
    },
    createTripEntryColumn : function(columns){
        columns.add(this.createColumn("startdate","开始日期","date","100px"));
		columns.add(this.createColumn("enddate","结束日期","date","100px"));
		columns.add(this.createColumn("from","出发地","basedata","100px"));
		columns.add(this.createColumn("to","目的地","basedata","100px"));
		columns.add(this.createColumn("vehicle","交通工具","combo","100px"));
		columns.add(this.createColumn("tripexpenseitem","费用项目","basedata","100px"));
    },
    createColumn : function(number, caption, type, width){
        var txtColumn = new HashMap();

		txtColumn.put('dataIndex', number);
		txtColumn.put('header', new LocaleString(caption));
		txtColumn.put('vi', 63);
		txtColumn.put('w', new LocaleString(width));
		txtColumn.put('text-align', "default");

		var txtEditor = new HashMap();
		txtColumn.put('type', "text");
		
		if("date" == type){
			txtEditor.put('type', "date");
			txtEditor.put('df', "YYYY-MM-DD");
		}else if("basedata" == type){
			txtEditor.put('dsp', "name");
			txtEditor.put('type', "basedata");
		}else if("number" == type){
    		txtEditor.put('type', "number");
		}else if("combo" == type){
    		txtEditor.put('type', "combo");
    		var items = new ArrayList();
    		
    		var o1 = new ArrayList();
    		o1.add("1");
    		o1.add(new LocaleString("飞机"));
    		o1.add(null);
    		items.add(o1);
    		
    		var o2 = new ArrayList();
    		o2.add("2");
    		o2.add(new LocaleString("火车"));
    		o2.add(null);
    		items.add(o2);
    		
    		var o3 = new ArrayList();
    		o3.add("3");
    		o3.add(new LocaleString("汽车"));
    		o3.add(null);
    		items.add(o3);

    		var o4 = new ArrayList();
    		o4.add("4");
    		o4.add(new LocaleString("轮船"));
    		o4.add(null);
    		items.add(o4);

    		var o5 = new ArrayList();
    		o5.add("5");
    		o5.add(new LocaleString("其他"));
    		o5.add(null);
    		items.add(o5);
    		txtEditor['st'], items;
		}
		
		txtColumn['editor'] = txtEditor;
		return txtColumn;
    },
    afterCreateNewData : function(e){
		this.getModel().batchCreateNewEntryRow(this.KEY_ENTRYENTITY, 1);
		this.getModel().setValue("from", "广州", 0);
		this.getModel().setValue("to", "北京", 0);
		this.getModel().setValue("startdate", "2018-08-15", 0);
		this.getModel().setValue("enddate", "2018-08-30", 0);
		this.getModel().setValue("vehicle", 1, 0);
		this.getModel().setValue("tripexpenseitem", null, 0);
    }
});]]></context><bizappid>83bfebc800003dac</bizappid><bizunitid>10QKP71OR9NZ</bizunitid><scriptname>动态控件样例</scriptname><creater_id>13466739</creater_id><createdate>1563168241000</createdate><modifydate>1573904405000</modifydate><modifier_id>13466739</modifier_id><isv>kingdee</isv><classname>kingdee.dev.devportal.scriptdemo.bos_devp_sample_control</classname></KScript></Scripts><BOSVersion>1.0</BOSVersion></DeployScript>